package xmodules

import "github.com/d5/tengo/v2/stdlib"
import "surdeus.su/core/xgo/xmodules/cjson"
import "surdeus.su/core/xgo/xmodules/logx"
import "surdeus.su/core/xgo/xmodules/paths"
import "surdeus.su/core/xgo/xmodules/httpx"
import "surdeus.su/core/xgo/xmodules/htmlx"
import "surdeus.su/core/xgo/xmodules/objects"
import "surdeus.su/core/xgo/xmodules/enumx"
import "github.com/d5/tengo/v2"

// The main map to import all the implemented modules.
func GetModules() *tengo.ModuleMap {
	ret := stdlib.GetModuleMap(stdlib.AllModuleNames()...)
	ret.AddBuiltinModule("cjson", cjson.Module)
	ret.AddBuiltinModule("log", logx.Module)
	ret.AddBuiltinModule("paths", paths.Module)
	ret.AddBuiltinModule("http", httpx.Module)
	ret.AddBuiltinModule("html", htmlx.Module)
	ret.Add("objects", objects.GetModule())
	ret.Add("enumx", enumx.GetModule())
	return ret
}
